import {
  Actions,
  ActionType,
} from './request.action';

import {
  State,
  initialState,
} from './request.state';
import { DiscoveryStatusType } from '../../../core/type';

export function reducer(state: State = initialState, action: Actions): State {
  switch (action.type) {
    case ActionType.RequestDiscover: {
      return {
        ...state,
        discoverySession: action.payload.discoverySession,
        discoveryStatus: DiscoveryStatusType.Requested,
      };
    }

    case ActionType.RequestDiscoverStop: {
      return {
        ...state,
        discoveryStatus: DiscoveryStatusType.Stopping,
      };
    }

    case ActionType.ChangeDiscoveryMode: {
      return {
        ...state,
        discoveryMode: action.payload.discoveryMode,
      };
    }

    case ActionType.ChangeDiscoveryStatus: {
      return {
        ...state,
        discoveryStatus: action.payload.discoveryStatus,
      };
    }

    case ActionType.DiscoveryComplete: {
      return {
        ...state,
        discoverySession: null,
      };
    }

    default: {
      return state;
    }
  }
}
