import { Type } from '@angular/core';
import {
  Selector,
  createSelector,
  combineReducers
} from '@ngrx/store';

import * as InterfacesStore from './interfaces';
import * as UserStore from './user';


export interface State {
  interfaces: InterfacesStore.State;
  user: UserStore.State;
}

export const EFFECTS: Type<any>[] = [
  InterfacesStore.InterfacesEffects,
  UserStore.UserEffects,
];

export const REDUCER = combineReducers({
  interfaces: InterfacesStore.reducer,
  user: UserStore.reducer,
});

export function getSelectors<S>(selector: Selector<any, State>) {
  return {
    InterfacesSelector: InterfacesStore.getSelectors(createSelector(
      selector,
      (state: State) => state.interfaces,
    )),
    UserSelector: UserStore.getSelectors(createSelector(
      selector,
      (state: State) => state.user,
    )),
  };
}
