import { Action } from '@ngrx/store';
import { Interface } from '@overflow/model/net/nic';

export enum ActionType {
  SetMemberID = '[app.environment] SetMemberID',

  ChangeShowWelcomPage = '[app.environment] ChangeShowWelcomPage',
}

export class SetMemberID implements Action {
  readonly type = ActionType.SetMemberID;

  constructor(public payload: { memberID: string }) { }
}

export class ChangeShowWelcomPage implements Action {
  readonly type = ActionType.ChangeShowWelcomPage;

  constructor(public payload: { showWelcomPage: boolean }) { }
}

export type Actions =
  | SetMemberID
  | ChangeShowWelcomPage
  ;
