import { Selector, createSelector } from '@ngrx/store';

export interface State {
  memberID: string | null;

  showWelcomPage: boolean;
}

export const initialState: State = {
  memberID: null,

  showWelcomPage: true,
};


export function getSelectors<S>(selector: Selector<any, State>) {
  return {
    selectMemberID: createSelector(selector, (state: State) => state.memberID),
    selectShowWelcomPage: createSelector(selector, (state: State) => state.showWelcomPage),
  };
}
