import { Type } from '@angular/core';
import {
  Selector,
  createSelector,
  combineReducers
} from '@ngrx/store';

import * as TargetStore from './target';


export interface State {
  target: TargetStore.State;
}

export const EFFECTS: Type<any>[] = [
  TargetStore.TargetEffects,
];

export const REDUCER = combineReducers({
  target: TargetStore.reducer,
});

export function getSelectors<S>(selector: Selector<any, State>) {
  return {
    TargetSelector: TargetStore.getSelectors(createSelector(
      selector,
      (state: State) => state.target,
    )),
  };
}
